package com.brilliance.isc.funds.basesel.trncod.service.impl;


import com.brilliance.isc.bo.Busbtn;
import com.brilliance.isc.bo.Cbb;
import com.brilliance.isc.bo.Trn;
import com.brilliance.isc.bo.model.Cpdgrp;
//import com.brilliance.isc.bo.remit.CptadvStoreBo;
//import com.brilliance.isc.bo.remit.CptopnStoreBo;
import com.brilliance.isc.bo.model.Ftdgrp;
import com.brilliance.isc.common.cbsmod.service.CbsmodService;
//import com.brilliance.isc.common.component.CpToolComponent;
import com.brilliance.isc.common.sysmod.SysmodService;
import com.brilliance.isc.funds.basesel.common.FtToolComponent;
import com.brilliance.isc.funds.basesel.trncod.consts.ErrorPrompt;
import com.brilliance.isc.funds.basesel.trncod.service.TrncodService;
import com.brilliance.isc.mda.dao.BusbtnMapper;
import com.brilliance.isc.mda.dao.TrnMapper;
import com.brilliance.isc.vo.TrnCodeQueryVo;
import com.brilliance.isc.vo.TrncodVo;
import com.brilliance.mda.runtime.mda.util.Dates;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.google.common.collect.Lists;
import org.checkerframework.checker.units.qual.C;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;
import java.util.Objects;

@Service
public class TrncodServiceImpl implements TrncodService {

    @Resource
    private BusbtnMapper busbtnMapper;
    @Resource
    private TrncodService trncodService;

    @Resource
    private TrnMapper trnMapper;
    @Resource
    private SysmodService sysmodService;
    @Resource
    private CbsmodService cbsmodService;

    @Resource
    private FtToolComponent ftToolComponent;
    @Override
    public String isFTTrnAllowed(Ftdgrp ftdgrp, String trnNam) {
        ftdgrp.reset();
        trnNam = trnNam.toUpperCase();
        String errMsg = "";
        switch(trnNam){
            case "FTTFMT":
                if(MdaUtils.isEmpty(ftdgrp.getRec().getInr())){
                    errMsg += ErrorPrompt.ErrSelN;}
//                }else {
//                    if(!MdaUtils.isEmpty(ftdgrp.getRec().getClsdat())){
//                        errMsg += ErrorPrompt.ErrClsY;
//                    }
//                    if(MdaUtils.isEmpty(cpdgrp.getRec().getOpndat())){
//                        errMsg += ErrorPrompt.ErrOpnN;
//                    }
//                    if(!MdaUtils.equals(cpdgrp.getRec().getAccmod(),"2")){
//                        errMsg += "业务未挂账！\n";
//                    }
//                }
                break;
            case "FTTFCN":
                if(MdaUtils.isEmpty(ftdgrp.getRec().getInr())){
                    errMsg += ErrorPrompt.ErrSelN;
                }
//                }else {
//                    if (!MdaUtils.isEmpty(cpdgrp.getRec().getClsdat())) {
//                        errMsg += ErrorPrompt.ErrClsY;
//                    }
//                }
//                break;
//            case "CPTROP":
//                if(MdaUtils.isEmpty(cpdgrp.getRec().getInr())){
//                    errMsg += ErrorPrompt.ErrSelN;
//                }else {
//                    if (MdaUtils.isEmpty(cpdgrp.getRec().getClsdat())) {
//                        errMsg += ErrorPrompt.ErrClsN;
//                    }
//                }
                break;
            case "CPTFEE":
            case "CPTFRE":
            case "CPTATT":
            case "JSTOPN":
                if(MdaUtils.isEmpty(ftdgrp.getRec().getInr())){
                    errMsg += ErrorPrompt.ErrSelN;
                }
                break;
            default:
                errMsg += "";
                break;
        }
        return  errMsg;

    }



    @Override
    public List<TrncodVo> dealWithByInr(TrnCodeQueryVo trnCodeQueryVo) {
        List<TrncodVo> result = Lists.newArrayList();
        //获取模型数据
        Ftdgrp cpdgrp = ftToolComponent.getCpdgrpByInr(trnCodeQueryVo.getInr());
        List<Busbtn> busbtnList = busbtnMapper.selectByBustypAndIsShow(trnCodeQueryVo.getType());
        String disResult = "";

        Cbb gz1amt = new Cbb();
        cbsmodService.cbsGetBalance(gz1amt, "CPD", trnCodeQueryVo.getInr(), "GZ1AMT", "AMT1", Dates.today());
        Cbb jf1amt = new Cbb();
        cbsmodService.cbsGetBalance(jf1amt, "CPD", trnCodeQueryVo.getInr(), "JF1AMT", "AMT1", Dates.today());
        Cbb th1amt = new Cbb();
        cbsmodService.cbsGetBalance(th1amt, "CPD", trnCodeQueryVo.getInr(), "TH1AMT", "AMT1", Dates.today());

        for (int i = 0; i < busbtnList.size(); i++) {
            //按钮亮灰显逻辑
            disResult = "";
//            if ("资金拆借".equals(busbtnList.get(i).getBtnnam())) {
//                // 如果btnnam是"挂账退汇"
//                if (gz1amt.getAmt() != null && gz1amt.getAmt().compareTo(BigDecimal.ZERO) > 0) {
//                } else {
//                    disResult = "业务未挂账！\n";
//                }
//            } else if ("头寸调拨".equals(busbtnList.get(i).getBtnnam())) {
//                // 如果btnnam是"解付后退汇"
//                if (jf1amt.getAmt() != null && jf1amt.getAmt().compareTo(BigDecimal.ZERO) > 0) {
//                } else {
//                    disResult = "业务未解付！\n";
//                }
//            } else {
//                disResult = trncodService.isFTTrnAllowed(cpdgrp, busbtnList.get(i).getInifrm());
//            }
            TrncodVo trncodVo = new TrncodVo(busbtnList.get(i).getInifrm(), busbtnList.get(i).getBtnnam(), MdaUtils.isEmpty(disResult) ? "Y" : "N", busbtnList.get(i).getIsMain(), disResult);
            result.add(trncodVo);
        }
        return result;
    }



    @Override
    public Object selectXxdByPrimaryKey(Map<String, String> map) {
        String objinr = map.get("objinr");
        String objtyp = map.get("objtyp");
//      String pntinr = map.get("pntinr");
        String paytyp = map.get("paytyp");
//        switch(paytyp) {
//            case "I":
//                CptadvStoreBo cptadvStoreBo = new CptadvStoreBo();
//                cptadvStoreBo.reset();
//                if(objinr.length() == 16) {
//                    Trn trnCpdI = trnMapper.selectByObjinrTrn(objtyp, objinr, "FTTFMT");
//                    if (!Objects.isNull(trnCpdI)) {
//                        cptadvStoreBo = sysmodService.streamGetNameInSubDir(CptadvStoreBo.class, trnCpdI.getInr());
//                    }
//                }
//                cptadvStoreBo.setCpdgrp(cpToolComponent.getCpdgrpByInr(objinr));
//                return cptadvStoreBo;
//            case "O":
//                CptopnStoreBo cptopnStoreBo = new CptopnStoreBo();
//                cptopnStoreBo.reset();
//                if(objinr.length() == 16) {
//                    Trn trnCpdO = trnMapper.selectByObjinrTrn(objtyp, objinr, "FTTFCN");
//                    if (!Objects.isNull(trnCpdO)) {
//                        cptopnStoreBo = sysmodService.streamGetNameInSubDir(CptopnStoreBo.class, trnCpdO.getInr());
//                    }
//                }
//                cptopnStoreBo.setCpdgrp(cpToolComponent.getCpdgrpByInr(objinr));
//                return cptopnStoreBo;
//        }
        return null;
    }

}
